
double alea (double a, double b, int option) 
{				// random number (uniform distribution) in  [a b]
	double r;
	
	switch(option)
	{
			case 0: // KISS
			r=(double)rand_kiss()/RAND_MAX_KISS;
			break;
			
			default:
			case 4: // False-random numbers have been read on a file
	 if(nCycle>=nCycleMax) nCycle=0;
	  r=randNumber[nCycle];
	  nCycle++;
			break;
	}

	nbRand++;
	 r=a+r*(b-a);
	return r; 
}
//================================================== KISS
/*
 A good pseudo-random numbers generator

 The idea is to use simple, fast, individually promising
 generators to get a composite that will be fast, easy to code
 have a very long period and pass all the tests put to it.
 The three components of KISS are
 x(n)=a*x(n-1)+1 mod 2^32
	 y(n)=y(n-1)(I+L^13)(I+R^17)(I+L^5),
	 z(n)=2*z(n-1)+z(n-2) +carry mod 2^32
		 The y's are a shift register sequence on 32bit binary vectors
		 period 2^32-1;
	 The z's are a simple multiply-with-carry sequence with period
		 2^63+2^32-1.  The period of KISS is thus
		 2^32*(2^32-1)*(2^63+2^32-1) > 2^127
			 */

static ulong kiss_x; //= 1;
static ulong kiss_y; //= 2;
static ulong kiss_z; //= 4;
static ulong kiss_w; //= 8;
static ulong kiss_carry = 0;
static ulong kiss_k;
static ulong kiss_m;



void seed_rand_kiss(ulong seed) 
{
	kiss_x = seed | 1;
	kiss_y = seed | 2;
	kiss_z = seed | 4;
	kiss_w = seed | 8;
	kiss_carry = 0;
}

ulong rand_kiss() 
{
	kiss_x = kiss_x * 69069 + 1;
	kiss_y ^= kiss_y << 13;
	kiss_y ^= kiss_y >> 17;
	kiss_y ^= kiss_y << 5;
	kiss_k = (kiss_z >> 2) + (kiss_w >> 3) + (kiss_carry >> 2);
	kiss_m = kiss_w + kiss_w + kiss_z + kiss_carry;
	kiss_z = kiss_w;
	kiss_w = kiss_m;
	kiss_carry = kiss_k >> 30;
	//printf("\n%f ",(double) (kiss_x + kiss_y + kiss_w));
	return kiss_x + kiss_y + kiss_w;
}